Attribute VB_Name = "Module1"
Public Dx As DirectX8
Public D3D As Direct3D8
Public D3DDevice As Direct3DDevice8
Public D3DX As D3DX8
Public VBuffer(10) As Direct3DVertexBuffer8
Public VBuffer_Kiste(10) As Direct3DVertexBuffer8
Public Texture As Direct3DTexture8
Public Texture2 As Direct3DTexture8
Public TextRect As RECT
Public MainFont As D3DXFont
Public MainFontDesc As IFont
Public fnt As New StdFont
Public RotateAngle As Single
Public RotatePoint As Integer
    
Public Type LITVERTEX
    X As Single
    Y As Single
    Z As Single
    color As Long
    Specular As Long
    tu As Single
    tv As Single
End Type

Public Waves(2000) As LITVERTEX
Public cube(36) As LITVERTEX

Public Const C000 As Long = 255     '//Red
Public Const C001 As Long = 65280  '//Green
Public Const C100 As Long = 16711680   '//Blue
Public Const C101 As Long = 16711935 '//Magenta
Public Const C010 As Long = 65535 '//Yellow
Public Const C011 As Long = 16776960 '//Cyan
Public Const C110 As Long = 16777215 '//White
Public Const C111 As Long = 8421631 '//Orange
Public Const Lit_FVF = (D3DFVF_XYZ Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR Or D3DFVF_TEX1)
Public Const pi As Single = 3.14159265358979   '(4*atn(1))

Public bRunning As Boolean

Public matWorld As D3DMATRIX
Public matView As D3DMATRIX
Public matProj As D3DMATRIX
Public matTemp As D3DMATRIX

Public Declare Function GetTickCount Lib "kernel32" () As Long
Public FPS_LastCheck As Long
Public FPS_Count As Long
Public FPS_Highest As Long
Public FPS_Current As Integer

Public Function Initialise() As Boolean
    On Error GoTo ErrHandler:
    
    Dim DispMode As D3DDISPLAYMODE
    Dim D3DWindow As D3DPRESENT_PARAMETERS
    
    Set Dx = New DirectX8
    Set D3D = Dx.Direct3DCreate()
    Set D3DX = New D3DX8
    
    DispMode.Format = D3DFMT_X8R8G8B8
    'DispMode.Format = D3DFMT_R5G6B5
    DispMode.Width = 1024
    DispMode.Height = 768
    
    D3DWindow.SwapEffect = D3DSWAPEFFECT_FLIP
    D3DWindow.BackBufferCount = 1
    D3DWindow.BackBufferFormat = DispMode.Format
    D3DWindow.BackBufferWidth = 1024
    D3DWindow.BackBufferHeight = 768
    D3DWindow.hDeviceWindow = Form1.hWnd
    D3DWindow.EnableAutoDepthStencil = 1
    
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16) = D3D_OK Then
        D3DWindow.AutoDepthStencilFormat = D3DFMT_D16
    Else
        'andere Modi
    End If
    
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16) = D3D_OK Then
        Debug.Print "16 bit Z-Buffers are supported (D3DFMT_D16)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16_LOCKABLE) = D3D_OK Then
        Debug.Print "Lockable 16 bit Z-Buffers are supported (D3DFMT_D16_LOCKABLE)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24S8) = D3D_OK Then
        Debug.Print "32 bit divided between 24 bit Depth and 8 bit stencil are supported (D3DFMT_D24S8)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24X4S4) = D3D_OK Then
        Debug.Print "32 bit divided between 24 bit depth, 4 bit stencil and 4 bit unused (D3DFMT_D24X4S4)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24X8) = D3D_OK Then
        Debug.Print "24 bit Z-Buffer supported (D3DFMT_D24X8)"
    End If
                        
    If D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DispMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D32) = D3D_OK Then
        Debug.Print "Pure 32 bit Z-buffer supported (D3DFMT_D32)"
    End If
    
    Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Form1.hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, _
                                                            D3DWindow)
    
    D3DDevice.SetVertexShader Lit_FVF
    
    D3DDevice.SetRenderState D3DRS_LIGHTING, 0
    D3DDevice.SetRenderState D3DRS_AMBIENT, &H202020
    D3DDevice.SetRenderState D3DRS_CULLMODE, 1
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    D3DDevice.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
    D3DDevice.SetRenderState D3DRS_SRCBLEND, 3 '2 (hell) oder 3 (etwas dunkler)
    D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
    D3DDevice.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
    
    Set Texture = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\wasser.jpg", 128, 128, D3DX_DEFAULT, 0, DispMode.Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
    Set Texture2 = D3DX.CreateTextureFromFile(D3DDevice, App.Path & "\kiste.jpg")
    
    FPS_Current = 0
    move = 0
    TextRect.Top = 0
    TextRect.bottom = 20
    TextRect.Right = 75
    fnt.Name = "Arial"
    fnt.Size = 12
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixLookAtLH matView, MakeVector(10, 40, 50), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView '0,80,100
    
    D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1, 0.1, 500
    D3DDevice.SetTransform D3DTS_PROJECTION, matProj
    
    If InitialiseGeometry() = True Then
        Initialise = True
        Exit Function
    End If
    
ErrHandler:
    
    Debug.Print "Error Number Returned: " & Err.Number
    Initialise = False
End Function

Public Function InitialiseGeometry() As Boolean
    
    On Error GoTo BailOut:
        
InitialiseGeometry = True
Exit Function
BailOut:
InitialiseGeometry = False
End Function

Public Sub CreateCubes(vert As Long, move As Single, gre As Single, X As Single, Y As Single, Z As Single)
    On Error GoTo BailOut:
    
    
    'Front
    cube(0) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 0)
    cube(1) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 1, 1)
    cube(2) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z + gre, C110, 0, 0, 1)
    cube(3) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 1, 1)
    cube(4) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 0)
    cube(5) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z + gre, C110, 0, 1, 0)

            
    'Back
    cube(6) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 1)
    cube(7) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z - gre, C110, 0, 1, 0)
    cube(8) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)
    cube(9) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 1)
    cube(10) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 1, 0)
    cube(11) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)

            
    'Right
    cube(12) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 1)
    cube(13) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z + gre, C110, 0, 1, 0)
    cube(14) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)
    cube(15) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z + gre, C110, 0, 0, 1)
    cube(16) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 1, 0)
    cube(17) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 0)
            
    'Left
    cube(18) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 1)
    cube(19) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 1, 0)
    cube(20) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)
    cube(21) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 0, 1)
    cube(22) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z - gre, C110, 0, 1, 0)
    cube(23) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 0)

    'Top
    cube(24) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z + gre, C110, 0, 0, 1)
    cube(25) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 1, 0)
    cube(26) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 0)
    cube(27) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z + gre, C110, 0, 0, 1)
    cube(28) = CreateLitVertex(X - gre, Sin(Y + move) + gre, Z - gre, C110, 0, 1, 0)
    cube(29) = CreateLitVertex(X + gre, Sin(Y + move) + gre, Z - gre, C110, 0, 0, 0)

    'Top
    cube(30) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 1)
    cube(31) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z + gre, C110, 0, 1, 0)
    cube(32) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)
    cube(33) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z + gre, C110, 0, 0, 1)
    cube(34) = CreateLitVertex(X - gre, Sin(Y + move) - gre, Z - gre, C110, 0, 1, 0)
    cube(35) = CreateLitVertex(X + gre, Sin(Y + move) - gre, Z - gre, C110, 0, 0, 0)
    
    Set VBuffer_Kiste(vert) = D3DDevice.CreateVertexBuffer(Len(cube(0)) * 36, 0, Lit_FVF, D3DPOOL_DEFAULT)
    D3DVertexBuffer8SetData VBuffer_Kiste(vert), 0, Len(cube(0)) * 36, 0, cube(0)
    
BailOut:
Exit Sub
End Sub

Public Sub CreateWaves(move As Single, Wellenhhe As Single, Fliesgeschwindigkeit As Single, Lnge As Single, Breite As Single)
    On Error GoTo BailOut:
    
    Dim X As Single
            
    For X = -15 To 15
        Waves((X + 15) * 2 + 0) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , Breite, C110, 0, ((X + 15) / 30) + move / Fliesgeschwindigkeit, 1)
        Waves((X + 15) * 2 + 1) = CreateLitVertex(X * Lnge, Sin(X + move) * Wellenhhe _
            , -Breite, C010, 0, ((X + 15) / 30) + move / Fliesgeschwindigkeit, 0)
    Next X
        
    Set VBuffer(0) = D3DDevice.CreateVertexBuffer(Len(Waves(0)) * 120, 0, Lit_FVF, D3DPOOL_DEFAULT)
    D3DVertexBuffer8SetData VBuffer(0), 0, Len(Waves(0)) * 120, 0, Waves(0)

BailOut:
Exit Sub
End Sub

Public Sub Render(move As Single)
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    Call CreateWaves(move, 1, 50, 2, 30)
    Call CreateCubes(0, move, 1, 0, 0, 0)
    
    D3DDevice.BeginScene
                
    If RotatePoint = 1 Then RotateAngle = RotateAngle + 0.1
    If RotatePoint = -1 Then RotateAngle = RotateAngle - 0.1
    If RotateAngle >= 10 Then RotatePoint = -1
    If RotateAngle <= -10 Then RotatePoint = 1
    
    D3DXMatrixIdentity matWorld
        
    D3DXMatrixIdentity matTemp
    D3DXMatrixRotationX matTemp, RotateAngle * (pi / 180)
    D3DXMatrixMultiply matWorld, matWorld, matTemp
        
    D3DXMatrixIdentity matTemp
    D3DXMatrixRotationZ matTemp, RotateAngle * (pi / 180)
    D3DXMatrixMultiply matWorld, matWorld, matTemp
        
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    D3DDevice.SetTexture 0, Texture2
    D3DDevice.SetStreamSource 0, VBuffer_Kiste(0), Len(cube(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 12
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetTexture 0, Texture
    D3DDevice.SetStreamSource 0, VBuffer(0), Len(Waves(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    
    D3DX.DrawText MainFont, &HFFFFCC00, CStr(FPS_Current) & "fps", TextRect, DT_TOP Or DT_LEFT
    
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Function CreateLitVertex(X As Single, Y As Single, Z As Single, Diffuse As Long, Specular As Long, tu As Single, tv As Single) As LITVERTEX
    CreateLitVertex.X = X
    CreateLitVertex.Y = Y
    CreateLitVertex.Z = Z
    CreateLitVertex.color = Diffuse
    CreateLitVertex.Specular = Specular
    CreateLitVertex.tu = tu
    CreateLitVertex.tv = tv
End Function

Public Function MakeVector(X As Single, Y As Single, Z As Single) As D3DVECTOR
    MakeVector.X = X
    MakeVector.Y = Y
    MakeVector.Z = Z
End Function
